"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var overwrite_service_1 = require("../../shared/services/overwrite.service");
exports.FOX_TEXTAREA_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return CodeareaComponent; }),
    multi: true
};
var CodeareaComponent = (function () {
    function CodeareaComponent(overwriteService) {
        this.overwriteService = overwriteService;
        this.name = '';
        this.clicked = new core_1.EventEmitter();
        this.changed = new core_1.EventEmitter();
        this.focused = new core_1.EventEmitter();
        this.blured = new core_1.EventEmitter();
        this.areaInstance = null;
        this.innerValue = '';
        this.onTouchedCallback = function () { };
        this.onChangeCallback = function () { };
        this.defaultSettings = overwriteService.getSettings('codearea');
    }
    CodeareaComponent.prototype.ngOnInit = function () {
        this.settings = Object.assign({}, this.defaultSettings, this.settings);
    };
    CodeareaComponent.prototype.ngOnChanges = function (changes) {
        if (changes.settings) {
            var data = Object.assign({}, changes.settings.previousValue, changes.settings.currentValue);
            this.settings = Object.assign({}, this.defaultSettings, data);
        }
    };
    CodeareaComponent.prototype.ngAfterViewInit = function () {
        this.codeMirrorInit();
    };
    CodeareaComponent.prototype.codeMirrorInit = function () {
        var _this = this;
        this.areaInstance = CodeMirror.fromTextArea(this.codeareaEl.nativeElement, this.settings);
        this.areaInstance.setValue(this.value);
        this.areaInstance.on('change', function () {
            _this.updateData(_this.areaInstance.getValue());
        });
        this.areaInstance.on('focus', function () {
            _this.focused.emit();
        });
        this.areaInstance.on('blur', function () {
            _this.blured.emit();
        });
    };
    CodeareaComponent.prototype.onBlur = function (event) {
        this.onTouchedCallback();
    };
    CodeareaComponent.prototype.onClick = function (event) {
        this.clicked.emit({ originalEvent: event });
    };
    CodeareaComponent.prototype.onChange = function (event) {
        this.changed.emit({ value: this.innerValue });
    };
    CodeareaComponent.prototype.updateData = function (data) {
        this.value = data;
        this.onTouchedCallback();
        this.changed.emit(data);
    };
    Object.defineProperty(CodeareaComponent.prototype, "value", {
        get: function () {
            return this.innerValue;
        },
        set: function (value) {
            if (value !== this.innerValue) {
                this.innerValue = value;
                this.onChangeCallback(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    CodeareaComponent.prototype.writeValue = function (value) {
        if (value == undefined) {
            value = '';
        }
        if (value !== this.innerValue) {
            this.innerValue = value;
            if (this.areaInstance) {
                this.areaInstance.setValue(value);
            }
        }
    };
    CodeareaComponent.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
    };
    CodeareaComponent.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
    };
    return CodeareaComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], CodeareaComponent.prototype, "settings", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], CodeareaComponent.prototype, "name", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], CodeareaComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], CodeareaComponent.prototype, "clicked", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], CodeareaComponent.prototype, "changed", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], CodeareaComponent.prototype, "focused", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], CodeareaComponent.prototype, "blured", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", Object)
], CodeareaComponent.prototype, "areaInstance", void 0);
__decorate([
    core_1.ViewChild("codearea"),
    __metadata("design:type", core_1.ElementRef)
], CodeareaComponent.prototype, "codeareaEl", void 0);
CodeareaComponent = __decorate([
    core_1.Component({
        moduleId: module.id,
        selector: 'fox-codearea',
        templateUrl: 'codearea.component.html',
        providers: [exports.FOX_TEXTAREA_CONTROL_VALUE_ACCESSOR]
    }),
    __metadata("design:paramtypes", [overwrite_service_1.OverwriteService])
], CodeareaComponent);
exports.CodeareaComponent = CodeareaComponent;
//# sourceMappingURL=codearea.component.js.map