import { OnInit, OnChanges, EventEmitter, ElementRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { ColorpickerSettings, ColorpickerLangs } from './colorpicker.model';
import { OverwriteService } from '../../shared/services/overwrite.service';
export declare const FOX_DATEPICKER_CONTROL_VALUE_ACCESSOR: any;
export declare class ColorpickerComponent implements OnInit, OnChanges, ControlValueAccessor {
    private el;
    private overwriteService;
    name: string;
    disabled: boolean;
    settings: ColorpickerSettings;
    langs: ColorpickerLangs;
    changed: EventEmitter<any>;
    clicked: EventEmitter<any>;
    showed: EventEmitter<any>;
    outsideClick: EventEmitter<any>;
    spectrumCanvasEl: ElementRef;
    hueCanvasEl: ElementRef;
    alphaCanvasEl: ElementRef;
    spectrumMarker: ElementRef;
    alphaMarker: ElementRef;
    hueMarker: ElementRef;
    colorLabel: ElementRef;
    dropped: boolean;
    currentHexColor: any;
    protected currentColorResults: any;
    protected innerValue: any;
    protected spectrumContext: CanvasRenderingContext2D;
    protected hueContext: CanvasRenderingContext2D;
    protected alphaContext: CanvasRenderingContext2D;
    protected currentRgbColor: any;
    protected currentHue: any;
    protected innerColor: any;
    protected isMouseDown: boolean;
    protected offset: {
        x: number;
        y: number;
    };
    protected hueCords: {
        x: number;
        y: number;
    };
    protected spectrumCords: {
        x: number;
        y: number;
    };
    protected alphaCords: {
        x: number;
        y: number;
    };
    protected defaultSettings: ColorpickerSettings;
    protected defaultLangs: ColorpickerLangs;
    protected onTouchedCallback: () => void;
    protected onChangeCallback: (_: any) => void;
    constructor(el: ElementRef, overwriteService: OverwriteService);
    ngOnInit(): void;
    ngOnChanges(changes: any): void;
    onClickOutside(event: any, targetElement: HTMLElement): void;
    drawHueGradient(): void;
    drawAlphaGradient(): void;
    drawSpectrumGradient(): void;
    draw(): void;
    show(event: any): void;
    color: any;
    initGradient(): void;
    getHueColorByPoint(x: number, y: number): string;
    getSpectrumColorByPoint(x: number, y: number): any;
    getAlphaColorByPoint(x: number, y: number): number;
    getImageData(context: CanvasRenderingContext2D, canvas: ElementRef, x: number, y: number): any;
    setMarkerCenter(marker: ElementRef, x: number, y?: number): void;
    colorSet(event: any, color: string): void;
    colorSelect(event: any, type: string): void;
    onCanvasMouseDown(event: any, type: string): void;
    toFormat(value: any, format?: string): any;
    onCanvasMouseUp(event: any): void;
    onCanvasMouseMove(event: any, type: string): void;
    onClick(event: any): void;
    onChange(event: any): void;
    value: any;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
}
