import { OnInit, OnChanges, EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { DatagridSettings, DatagridLangs, DatagridRoutes, RouteItem, LazyloadEvent } from './datagrid.model';
import { PaginationSettings } from '../pagination/pagination.model';
import { SelectSettings } from '../select/select.model';
import { PopoverComponent } from '../popover/popover.component';
import { OverwriteService } from '../../shared/services/overwrite.service';
import { HelperService } from '../../shared/services/helper.service';
export declare class DatagridComponent implements OnInit, OnChanges {
    private router;
    private route;
    private overwriteService;
    private helperService;
    settings: DatagridSettings;
    langs: DatagridLangs;
    routes: DatagridRoutes;
    filters: any;
    rows: Array<any>;
    checkedItems: Array<any>;
    total: number;
    lazyLoad: EventEmitter<any>;
    remove: EventEmitter<any>;
    removeSelected: EventEmitter<any>;
    rowClick: EventEmitter<any>;
    rowSelect: EventEmitter<any>;
    rowUnselect: EventEmitter<any>;
    rowAction: EventEmitter<any>;
    filtersReseted: EventEmitter<any>;
    filtersSubmited: EventEmitter<any>;
    sortSubmited: EventEmitter<any>;
    isPreloaded: boolean;
    totalPages: number;
    protected totalRowsView: number;
    protected totalRowsViewOptions: Array<any>;
    protected paginationSettings: PaginationSettings;
    protected totalSettings: SelectSettings;
    protected defaultLangs: DatagridLangs;
    protected defaultSettings: DatagridSettings;
    protected currentPage: number;
    protected firstItem: number;
    protected sortedField: string;
    protected sortedOrder: 'asc' | 'desc';
    protected viewedItemsCount: number;
    protected filtersData: any;
    constructor(router: Router, route: ActivatedRoute, overwriteService: OverwriteService, helperService: HelperService);
    ngOnInit(): void;
    ngOnChanges(changes: any): void;
    getViewedItemsCount(): number;
    getTotalPages(): number;
    onChangePage(event: any): void;
    onChangeTotal(event: any): void;
    calculateFirstRow(): number;
    changeGridData(): void;
    createLazyLoadData(): LazyloadEvent;
    rowClickHandler(event: any, row: any): void;
    rowSelectHandler(event: any, row: any): void;
    rowUnselectHandler(event: any, row: any): void;
    getChecked(): any[];
    rowCheckedHandler(event: any, row: any): void;
    rowCustomActionHandler(event: any, name: string, row: any): void;
    selectAllHandler(event: any, popover: PopoverComponent): void;
    unselectAllHandler(event: any, popover: PopoverComponent): void;
    removeSelectedHandler(event: any, popover: PopoverComponent): void;
    removeHandler(event: any, row: any, popover: PopoverComponent): void;
    routeNavigate(event: any, route: RouteItem, row?: any): void;
    closePopover(event: any, popover: PopoverComponent): void;
    buildFiltersObject(): any;
    filterSubmitHandler(event: any): void;
    resetFiltersHandler(event: any): void;
    filterChangedHandler(event: any): void;
    sortChangedHandler(event: any): void;
    fireLazyLoadEvent(): void;
    startPreloader(): void;
    stopPreloader(): void;
}
