import { OnInit, OnChanges, EventEmitter, ElementRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { DatepickerDate, DatepickerSettings, DatepickerLangs } from './datepicker.model';
import { OverwriteService } from '../../shared/services/overwrite.service';
export declare const FOX_DATEPICKER_CONTROL_VALUE_ACCESSOR: any;
export declare class DatepickerComponent implements OnInit, OnChanges, ControlValueAccessor {
    private el;
    private overwriteService;
    name: string;
    disabled: boolean;
    settings: DatepickerSettings;
    langs: DatepickerLangs;
    changed: EventEmitter<any>;
    clicked: EventEmitter<any>;
    showed: EventEmitter<any>;
    outsideClick: EventEmitter<any>;
    dropped: boolean;
    protected innerValue: any;
    protected days: Array<DatepickerDate>;
    protected date: any;
    protected datePattern: string;
    protected defaultSettings: DatepickerSettings;
    protected defaultLangs: DatepickerLangs;
    protected displayDate: string;
    protected onTouchedCallback: () => void;
    protected onChangeCallback: (_: any) => void;
    constructor(el: ElementRef, overwriteService: OverwriteService);
    ngOnInit(): void;
    ngOnChanges(changes: any): void;
    onClickOutside(event: any, targetElement: HTMLElement): void;
    show(event: any): void;
    changeTime(event: any, type: string, action: any): void;
    valueToMoment(values: any): any;
    buildCalendar(): void;
    isSameDate(currentDate: any, dates: any): boolean;
    selectDate(event: any, day: number): void;
    setSelectedDate(selected: any): boolean;
    removeSelectedDate(selected: any): void;
    isMaximumDatesSelected(): boolean;
    onClick(event: any): void;
    onChange(event: any): void;
    prevMonth(): void;
    nextMonth(): void;
    prevYear(): void;
    nextYear(): void;
    toFormat(value: any, format?: string): any;
    dayBgColor(day: DatepickerDate): string;
    notNulledDate(date: any): boolean;
    value: any;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
}
