import { OnInit, OnChanges, DoCheck, EventEmitter, ElementRef, KeyValueDiffers } from '@angular/core';
import { FileuploaderSettings, FileuploaderLangs } from './fileuploader.model';
import { OverwriteService } from '../../shared/services/overwrite.service';
export declare class FileuploaderComponent implements OnInit, OnChanges, DoCheck {
    private el;
    private overwriteService;
    private differs;
    name: string;
    disabled: boolean;
    settings: FileuploaderSettings;
    langs: FileuploaderLangs;
    files: any;
    clicked: EventEmitter<any>;
    rejected: EventEmitter<any>;
    preview: EventEmitter<any>;
    remove: EventEmitter<any>;
    upload: EventEmitter<any>;
    uploadProgress: EventEmitter<any>;
    uploadAbort: EventEmitter<any>;
    uploadError: EventEmitter<any>;
    uploadDone: EventEmitter<any>;
    fileInput: ElementRef;
    fileValue: any;
    protected onTouchedCallback: () => void;
    protected onChangeCallback: (_: any) => void;
    protected queueList: Array<any>;
    protected previewPrefix: string;
    protected progress: Object;
    protected done: boolean;
    protected error: boolean;
    protected abort: boolean;
    protected defaultSettings: FileuploaderSettings;
    protected defaultLangs: FileuploaderLangs;
    protected differ: any;
    constructor(el: ElementRef, overwriteService: OverwriteService, differs: KeyValueDiffers);
    ngOnInit(): void;
    ngDoCheck(): void;
    ngOnChanges(changes: any): void;
    viewUploadDialog(event: any): void;
    onClick(event: any): void;
    onChange(event: any): void;
    addToQueue(files: Array<any>): void;
    uploadInQueue(): void;
    setUploadProgres(progress: Object): void;
    setUploadAbort(): void;
    setUploadError(): void;
    uploadFile(file: any): void;
    progressData(event: ProgressEvent): any;
    createFileUrl(file: File): void;
    isFile(file: any): boolean;
    inQueue(file: any): boolean;
    removeFromQueue(index: number): void;
    clearQueue(): void;
    clearAll(): void;
    getQueueLength(): number;
    filterByExtension(): void;
    extensionIsAllow(extension: string): boolean;
    fileExtensionIsAllow(extension: string): boolean;
    imageExtensionIsAllow(extension: string): boolean;
    convertBytes(bytes: number): string;
}
