import { OnInit, EventEmitter, ElementRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { MultiselectSettings, MultiselectLangs, MultiselectAjax } from './multiselect.model';
import { OverwriteService } from '../../shared/services/overwrite.service';
import { HelperService } from '../../shared/services/helper.service';
export declare const FOX_MULTISELECT_CONTROL_VALUE_ACCESSOR: any;
export declare class MultiselectComponent implements OnInit, ControlValueAccessor {
    private el;
    private overwriteService;
    private helperService;
    name: string;
    disabled: boolean;
    options: Array<any>;
    settings: MultiselectSettings;
    langs: MultiselectLangs;
    ajax: MultiselectAjax;
    ajaxSearch: boolean;
    selected: EventEmitter<any>;
    showed: EventEmitter<any>;
    outsideClick: EventEmitter<any>;
    dropped: boolean;
    title: string;
    protected innerValue: any;
    protected searchText: string;
    protected onTouchedCallback: () => void;
    protected onChangeCallback: (_: any) => void;
    protected defaultSettings: MultiselectSettings;
    protected defaultLangs: MultiselectLangs;
    protected defaultAjax: MultiselectAjax;
    constructor(el: ElementRef, overwriteService: OverwriteService, helperService: HelperService);
    ngOnInit(): void;
    ngOnChanges(changes: any): void;
    onClickOutside(event: any, targetElement: HTMLElement): void;
    clearSearch(event: any): void;
    searchTyping(event: any): void;
    buildName(values: any): void;
    isSelected(option: any): boolean;
    onSelect(event: any, option: any): void;
    changeInnerValue(): void;
    toggle(): void;
    checkAll(event: any): void;
    uncheckAll(): void;
    onBlur(event: any): void;
    value: any;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
}
