import { OnInit, OnChanges, EventEmitter, ElementRef } from '@angular/core';
import { ControlValueAccessor, NgModel } from '@angular/forms';
import { PaginationPage, PaginationSettings, PaginationLangs } from './pagination.model';
import { OverwriteService } from '../../shared/services/overwrite.service';
export declare class PaginationComponent implements ControlValueAccessor, OnInit, OnChanges {
    private el;
    private overwriteService;
    settings: PaginationSettings;
    langs: PaginationLangs;
    disabled: boolean;
    total: number;
    selected: EventEmitter<any>;
    prevClicked: EventEmitter<any>;
    nextClicked: EventEmitter<any>;
    lastClicked: EventEmitter<any>;
    firstClicked: EventEmitter<any>;
    model: NgModel;
    pages: Array<PaginationPage>;
    protected innerPage: number;
    protected onTouchedCallback: () => void;
    protected onChangeCallback: (_: any) => void;
    protected defaultSettings: PaginationSettings;
    protected defaultLangs: PaginationLangs;
    constructor(el: ElementRef, model: NgModel, overwriteService: OverwriteService);
    ngOnChanges(changes: any): void;
    ngOnInit(): void;
    private getPages(current);
    select(event: any, page: number): void;
    prevSelect(event: any, page: number): void;
    nextSelect(event: any, page: number): void;
    lastSelect(event: any): void;
    firstSelect(event: any): void;
    page: any;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    hasPrev(): boolean;
    hasNext(): boolean;
}
