"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var overwrite_service_1 = require("../../shared/services/overwrite.service");
exports.FOX_PASSWORD_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return PasswordComponent; }),
    multi: true
};
var PasswordComponent = (function () {
    function PasswordComponent(overwriteService) {
        this.overwriteService = overwriteService;
        this.name = '';
        this.placeholder = '';
        this.changed = new core_1.EventEmitter();
        this.clicked = new core_1.EventEmitter();
        this.generated = new core_1.EventEmitter();
        this.showPassword = false;
        this.strongAvailable = 5;
        this.strongValue = 0;
        this.innerValue = '';
        this.onTouchedCallback = function () { };
        this.onChangeCallback = function () { };
        this.defaultSettings = overwriteService.getSettings('password');
        this.defaultLangs = overwriteService.getLangs('password');
    }
    PasswordComponent.prototype.ngOnInit = function () {
        this.settings = Object.assign({}, this.defaultSettings, this.settings);
        this.langs = Object.assign({}, this.defaultLangs, this.langs);
    };
    PasswordComponent.prototype.ngOnChanges = function (changes) {
        if (changes.settings) {
            var data = Object.assign({}, changes.settings.previousValue, changes.settings.currentValue);
            this.settings = Object.assign({}, this.defaultSettings, data);
        }
        if (changes.langs) {
            var data = Object.assign({}, changes.langs.previousValue, changes.langs.currentValue);
            this.langs = Object.assign({}, this.defaultLangs, data);
        }
    };
    PasswordComponent.prototype.strong = function (password) {
        var matches = 0;
        // min length
        if (password.length > this.settings.minLength) {
            matches++;
        }
        // contains char
        if (/[a-z]+/.test(password)) {
            matches++;
        }
        // contains upper char
        if (/[A-Z]+/.test(password)) {
            matches++;
        }
        // contains symbols
        if (/[$@&+#-/:-?{-~!"^_`\[\]]/g.test(password)) {
            matches++;
        }
        // contains number
        if (/\d+/g.test(password)) {
            matches++;
        }
        this.strongValue = matches;
    };
    PasswordComponent.prototype.strongLevelClass = function (level) {
        if (level <= this.strongValue) {
            return 'fox-password__strong_' + level;
        }
        return;
    };
    PasswordComponent.prototype.generatePassword = function () {
        var length = this.settings.length;
        var string = "abcdefghijklmnopqrstuvwxyz";
        var numeric = '0123456789';
        var punctuation = '!@#$%^&*()_+~`|}{[]\:;?><,./-=';
        var password = "";
        var character = "";
        while (password.length < length) {
            var entity1 = Math.ceil(string.length * Math.random() * Math.random());
            var entity2 = Math.ceil(numeric.length * Math.random() * Math.random());
            var entity3 = Math.ceil(punctuation.length * Math.random() * Math.random());
            var hold = string.charAt(entity1);
            hold = (entity1 % 2 == 0) ? hold.toUpperCase() : hold;
            character += hold;
            character += numeric.charAt(entity2);
            character += punctuation.charAt(entity3);
            password = character;
        }
        this.value = password;
        this.strong(password);
        this.generated.emit({ password: password, strong: this.strongValue });
    };
    PasswordComponent.prototype.displayPassword = function () {
        this.showPassword = !this.showPassword;
    };
    PasswordComponent.prototype.onBlur = function (event) {
        this.onTouchedCallback();
    };
    PasswordComponent.prototype.onClick = function (event) {
        this.clicked.emit({ originalEvent: event });
    };
    PasswordComponent.prototype.onChange = function (event) {
        this.changed.emit({ ovalue: this.innerValue });
        this.strong(this.innerValue);
    };
    PasswordComponent.prototype.numberReturn = function (length) {
        var result = [];
        for (var i = 1; i <= length; i++) {
            result.push(i);
        }
        return result;
    };
    Object.defineProperty(PasswordComponent.prototype, "value", {
        get: function () {
            return this.innerValue;
        },
        set: function (value) {
            if (value !== this.innerValue) {
                this.innerValue = value;
                this.onChangeCallback(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    PasswordComponent.prototype.writeValue = function (value) {
        if (value !== this.innerValue) {
            this.innerValue = value;
        }
    };
    PasswordComponent.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
    };
    PasswordComponent.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
    };
    return PasswordComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], PasswordComponent.prototype, "settings", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], PasswordComponent.prototype, "langs", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], PasswordComponent.prototype, "name", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], PasswordComponent.prototype, "placeholder", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], PasswordComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], PasswordComponent.prototype, "changed", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], PasswordComponent.prototype, "clicked", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], PasswordComponent.prototype, "generated", void 0);
__decorate([
    core_1.ViewChild('passwordInput'),
    __metadata("design:type", core_1.ElementRef)
], PasswordComponent.prototype, "passwordInput", void 0);
PasswordComponent = __decorate([
    core_1.Component({
        moduleId: module.id,
        selector: 'fox-password',
        templateUrl: 'password.component.html',
        styleUrls: ['password.component.css'],
        providers: [exports.FOX_PASSWORD_CONTROL_VALUE_ACCESSOR]
    }),
    __metadata("design:paramtypes", [overwrite_service_1.OverwriteService])
], PasswordComponent);
exports.PasswordComponent = PasswordComponent;
//# sourceMappingURL=password.component.js.map