import { OnInit, OnChanges, AfterContentChecked, EventEmitter, ElementRef, Renderer } from '@angular/core';
import { ScrollbarSettings } from './scrollbar.model';
import { DomService } from '../../shared/services/dom.service';
import { OverwriteService } from '../../shared/services/overwrite.service';
export declare class ScrollbarDirective implements OnInit, OnChanges, AfterContentChecked {
    private el;
    private renderer;
    private positionService;
    private overwriteService;
    settings: ScrollbarSettings;
    width: string;
    height: string;
    protected defaultSettings: ScrollbarSettings;
    protected wrapper: HTMLElement;
    protected track: HTMLElement;
    protected thumb: HTMLElement;
    protected elNative: HTMLElement;
    protected body: HTMLElement;
    protected pageY: number;
    protected top: number;
    protected dragging: boolean;
    scrolling: EventEmitter<any>;
    mouseUp: EventEmitter<any>;
    mouseDown: EventEmitter<any>;
    constructor(el: ElementRef, renderer: Renderer, positionService: DomService, overwriteService: OverwriteService);
    ngOnInit(): void;
    ngOnChanges(changes: any): void;
    ngAfterContentChecked(): void;
    initElementStyle(): void;
    wrapElement(): void;
    initScrollbar(): void;
    initThumbHeight(): void;
    initEventListeners(): void;
    scroll(deltaY: number): void;
    private ThumbListener;
    private whellHandler;
}
