import { OnInit, OnChanges, AfterContentInit, EventEmitter, ElementRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { SliderSettings } from './slider.model';
import { OverwriteService } from '../../shared/services/overwrite.service';
export declare const FOX_SLIDER_CONTROL_VALUE_ACCESSOR: any;
export declare class SliderComponent implements OnInit, OnChanges, AfterContentInit, ControlValueAccessor {
    private el;
    private overwriteService;
    settings: SliderSettings;
    name: string;
    disabled: boolean;
    changed: EventEmitter<any>;
    clicked: EventEmitter<any>;
    track: ElementRef;
    thumb: ElementRef;
    thumbSecond: ElementRef;
    thumbPos: number;
    protected innerValue: any;
    protected onTouchedCallback: () => void;
    protected onChangeCallback: (_: any) => void;
    protected currentX: number;
    protected currentY: number;
    protected thumbSecondPos: number;
    protected range: Array<number>;
    protected isMouseDown: boolean;
    protected thumbWidth: number;
    protected defaultSettings: SliderSettings;
    protected selectedThumbType: 'start' | 'end';
    constructor(el: ElementRef, overwriteService: OverwriteService);
    ngOnInit(): void;
    ngOnChanges(changes: any): void;
    ngAfterContentInit(): void;
    createInnerValue(): any;
    onDocumentMouseMove(event: any): void;
    onDocumentMouseUp(event: any): void;
    thumbSelect(event: any, thumbType: any): void;
    thumbUnselect(event: any): void;
    thumbMove(event: any): void;
    moveToPosition(event: any): void;
    private placeThumb(step);
    private stepInRange();
    private calculateStepLength();
    private getElementCoords(element);
    private buildStepsRange();
    onClick(event: any): void;
    onChange(event: any): void;
    value: any;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
}
