import { OnInit, OnChanges, EventEmitter, ElementRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { TagItem, TagSettings, TagLangs } from './tag.model';
import { OverwriteService } from '../../shared/services/overwrite.service';
export declare class TagComponent implements ControlValueAccessor, OnInit, OnChanges {
    private overwriteService;
    private el;
    name: string;
    disabled: boolean;
    settings: TagSettings;
    langs: TagLangs;
    add: EventEmitter<Array<TagItem>>;
    removed: EventEmitter<TagItem>;
    tagsInput: ElementRef;
    tagsList: Array<TagItem>;
    searchText: string;
    keys: any;
    protected selected: number;
    protected defaultSettings: TagSettings;
    protected defaultLangs: TagLangs;
    protected onTouchedCallback: () => void;
    protected onChangeCallback: (_: any) => void;
    constructor(overwriteService: OverwriteService, el: ElementRef);
    ngOnInit(): void;
    ngOnChanges(changes: any): void;
    onClickOutside(event: any, targetElement: HTMLElement): void;
    onPaste(event: any): void;
    clipboardData(event: any): string;
    onKeydown(event: any): void;
    onBlur(event: any): void;
    isTagUnique(tagString: any): boolean;
    isTagValid(tagString: any): boolean;
    addTags(tags: Array<any>): void;
    removeTag(tagIndex: number): void;
    clearInput(): void;
    handleBackspace(): void;
    reselectTag(): void;
    onAutocompleteItem(event: any, item: TagItem): void;
    isBlank(obj: any): boolean;
    maxTagsListKey(): number;
    readonly inputValue: string;
    value: any;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
}
