"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var overwrite_service_1 = require("../../shared/services/overwrite.service");
exports.FOX_TYPEAHEAD_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return TypeaheadComponent; }),
    multi: true
};
var TypeaheadComponent = (function () {
    function TypeaheadComponent(el, overwriteService) {
        this.el = el;
        this.overwriteService = overwriteService;
        this.name = '';
        this.placeholder = '';
        this.changed = new core_1.EventEmitter();
        this.clicked = new core_1.EventEmitter();
        this.selected = new core_1.EventEmitter();
        this.lazyLoad = new core_1.EventEmitter();
        this.isHidden = true;
        this.searchText = '';
        this._list = [];
        this.innerValue = '';
        this.onTouchedCallback = function () { };
        this.onChangeCallback = function () { };
        this.defaultSettings = overwriteService.getSettings('typeahead');
        this.defaultLangs = overwriteService.getLangs('typeahead');
    }
    TypeaheadComponent.prototype.ngOnInit = function () {
        this.settings = Object.assign({}, this.defaultSettings, this.settings);
        this.langs = Object.assign({}, this.defaultLangs, this.langs);
    };
    TypeaheadComponent.prototype.ngOnChanges = function (changes) {
        if (changes.settings) {
            var data = Object.assign({}, changes.settings.previousValue, changes.settings.currentValue);
            this.settings = Object.assign({}, this.defaultSettings, data);
        }
        if (changes.langs) {
            var data = Object.assign({}, changes.langs.previousValue, changes.langs.currentValue);
            this.langs = Object.assign({}, this.defaultLangs, data);
        }
    };
    TypeaheadComponent.prototype.onClickOutside = function (event, targetElement) {
        if (!targetElement) {
            return;
        }
        var clickedInside = this.el.nativeElement.contains(targetElement);
        if (!clickedInside) {
            this.isHidden = true;
        }
    };
    TypeaheadComponent.prototype.onAutocompleteItem = function (item) {
        this.value = item[this.settings.valueField];
        this.searchInput = item[this.settings.titleField];
        this.selected.emit({ item: item, value: this.value });
        this.isHidden = true;
    };
    TypeaheadComponent.prototype.onBlur = function (event) {
        this.onTouchedCallback();
    };
    TypeaheadComponent.prototype.onClick = function (event) {
        if (this.searchText) {
            this.isHidden = false;
        }
        else {
            this.isHidden = true;
        }
        this.clicked.emit({ originalEvent: event });
    };
    TypeaheadComponent.prototype.onChange = function (event) {
        this.changed.emit({ value: this.innerValue });
    };
    TypeaheadComponent.prototype.onTyping = function () {
        if (this.settings.lazyload) {
            this.fireLazyLoadEvent();
        }
        if (this.searchText != '') {
            this.isHidden = false;
        }
        else {
            this.isHidden = true;
        }
    };
    TypeaheadComponent.prototype.findItemByValue = function (value) {
        var result;
        if (this.list && this.list.length) {
            for (var key in this.list) {
                if (this.list[key][this.settings.valueField] == value) {
                    return this.list[key];
                }
            }
        }
        return;
    };
    TypeaheadComponent.prototype.titleByObject = function (value) {
        var item = this.findItemByValue(value);
        return (item) ? item[this.settings.titleField] : value;
    };
    TypeaheadComponent.prototype.createLazyLoadData = function () {
        return {
            value: this.searchText
        };
    };
    TypeaheadComponent.prototype.fireLazyLoadEvent = function () {
        this.startPreloader();
        if (this.settings.lazyload) {
            this.lazyLoad.emit(this.createLazyLoadData());
        }
    };
    TypeaheadComponent.prototype.startPreloader = function () {
        this.isPreloaded = true;
    };
    TypeaheadComponent.prototype.stopPreloader = function () {
        this.isPreloaded = false;
    };
    Object.defineProperty(TypeaheadComponent.prototype, "list", {
        get: function () {
            return this._list;
        },
        set: function (value) {
            this._list = value;
            if (this.settings && this.value && this._list.length && this.settings.lazyload) {
                var item = this.findItemByValue(this.value);
                this.searchText = (item != undefined && item[this.settings.valueField] == this.searchText) ? this.titleByObject(this.value) : this.searchText;
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(TypeaheadComponent.prototype, "searchInput", {
        get: function () {
            if (this.searchText == '' && this.value) {
                this.searchText = this.titleByObject(this.value);
            }
            return this.searchText;
        },
        set: function (value) {
            this.searchText = value;
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(TypeaheadComponent.prototype, "value", {
        get: function () {
            return this.innerValue;
        },
        set: function (value) {
            if (value !== this.innerValue) {
                this.innerValue = value;
                this.onChangeCallback(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    TypeaheadComponent.prototype.writeValue = function (value) {
        if (value && value !== this.innerValue) {
            this.innerValue = value;
            this.searchText = this.searchInput;
            if (this.settings.lazyload) {
                this.fireLazyLoadEvent();
            }
        }
    };
    TypeaheadComponent.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
    };
    TypeaheadComponent.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
    };
    return TypeaheadComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], TypeaheadComponent.prototype, "settings", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], TypeaheadComponent.prototype, "langs", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], TypeaheadComponent.prototype, "name", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], TypeaheadComponent.prototype, "placeholder", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], TypeaheadComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], TypeaheadComponent.prototype, "changed", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], TypeaheadComponent.prototype, "clicked", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], TypeaheadComponent.prototype, "selected", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], TypeaheadComponent.prototype, "lazyLoad", void 0);
__decorate([
    core_1.HostListener('document:click', ['$event', '$event.target']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, HTMLElement]),
    __metadata("design:returntype", void 0)
], TypeaheadComponent.prototype, "onClickOutside", null);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], TypeaheadComponent.prototype, "list", null);
TypeaheadComponent = __decorate([
    core_1.Component({
        moduleId: module.id,
        selector: 'fox-typeahead',
        templateUrl: 'typeahead.component.html',
        styleUrls: ['typeahead.component.css'],
        providers: [exports.FOX_TYPEAHEAD_CONTROL_VALUE_ACCESSOR]
    }),
    __metadata("design:paramtypes", [core_1.ElementRef,
        overwrite_service_1.OverwriteService])
], TypeaheadComponent);
exports.TypeaheadComponent = TypeaheadComponent;
//# sourceMappingURL=typeahead.component.js.map