import { ValidatorFn, AbstractControl } from '@angular/forms';
export declare class ValidateService {
    /**
     * Email validation
     *
     * @static
     * @returns
     *
     * @memberOf ValidateService
     */
    static email(): (control: AbstractControl) => {
        [key: string]: any;
    };
    /**
     * Password validation
     *
     * @static
     * @param {number} [min=6]
     * @param {number} [max=100]
     * @returns
     *
     * @memberOf ValidateService
     */
    static password(min?: number, max?: number): (control: AbstractControl) => {
        [key: string]: any;
    };
    /**
     * Integer validation
     *
     * @static
     * @returns {ValidatorFn}
     *
     * @memberOf ValidateService
     */
    static int(): ValidatorFn;
    /**
     * Number validation
     *
     * @static
     * @returns {ValidatorFn}
     *
     * @memberOf ValidateService
     */
    static number(): ValidatorFn;
    /**
     * Date validation
     *
     * @static
     * @returns {ValidatorFn}
     *
     * @memberOf ValidateService
     */
    static date(): ValidatorFn;
    /**
     * Min date validation
     *
     * @static
     * @param {*} date
     * @returns {ValidatorFn}
     *
     * @memberOf ValidateService
     */
    static minDate(date: any): ValidatorFn;
    /**
     * Max date validation
     *
     * @static
     * @param {*} date
     * @returns {ValidatorFn}
     *
     * @memberOf ValidateService
     */
    static maxDate(date: any): ValidatorFn;
    /**
     * Value equeal validation
     *
     * @static
     * @param {*} value
     * @returns {ValidatorFn}
     *
     * @memberOf ValidateService
     */
    static equal(value: any): ValidatorFn;
    /**
     * Max value validation
     *
     * @static
     * @param {number} max
     * @returns {ValidatorFn}
     *
     * @memberOf ValidateService
     */
    static max(max: number): ValidatorFn;
    /**
     * Min value validation
     *
     * @static
     * @param {number} min
     * @returns {ValidatorFn}
     *
     * @memberOf ValidateService
     */
    static min(min: number): ValidatorFn;
    /**
     * Value range validation
     *
     * @static
     * @param {Array<number>} range
     * @returns {ValidatorFn}
     *
     * @memberOf ValidateService
     */
    static range(range: Array<number>): ValidatorFn;
    /**
     * Json validate
     *
     * @static
     * @returns {ValidatorFn}
     *
     * @memberOf ValidateService
     */
    static json(): ValidatorFn;
    /**
     * Boolean validate
     *
     * @static
     * @returns {ValidatorFn}
     *
     * @memberOf ValidateService
     */
    static boolean(): ValidatorFn;
    /**
     * Hex color validate
     *
     * @static
     * @returns {ValidatorFn}
     *
     * @memberOf ValidateService
     */
    static hex(): ValidatorFn;
    /**
     * Rgb color validate
     *
     * @static
     * @returns {ValidatorFn}
     *
     * @memberOf ValidateService
     */
    static rgb(): ValidatorFn;
}
