import { OnInit } from '@angular/core';
import { ButtonsSettings } from '../../components/buttons/buttons.model';
import { InputSettings } from '../../components/input/input.model';
import { TextareaSettings } from '../../components/textarea/textarea.model';
import { DropdownSettings } from '../../components/dropdown/dropdown.model';
import { TabSettings } from '../../components/tab/tab.model';
import { CheckboxSettings } from '../../components/checkbox/checkbox.model';
import { RadioSettings } from '../../components/radio/radio.model';
import { SelectSettings } from '../../components/select/select.model';
import { PopoverSettings } from '../../components/popover/popover.model';
import { TooltipSettings } from '../../components/tooltip/tooltip.model';
import { SpinnerSettings } from '../../components/spinner/spinner.model';
import { ModalSettings } from '../../components/modal/modal.model';
import { SwitcherSettings, SwitcherLangs } from '../../components/switcher/switcher.model';
import { SliderSettings } from '../../components/slider/slider.model';
import { PanelSettings } from '../../components/panel/panel.model';
import { ProgressSettings } from '../../components/progress/progress.model';
import { PaginationSettings, PaginationLangs } from '../../components/pagination/pagination.model';
import { MultiselectSettings, MultiselectLangs } from '../../components/multiselect/multiselect.model';
import { DatepickerSettings, DatepickerLangs } from '../../components/datepicker/datepicker.model';
import { ColorpickerSettings, ColorpickerLangs } from '../../components/colorpicker/colorpicker.model';
import { FileuploaderSettings, FileuploaderLangs } from '../../components/fileuploader/fileuploader.model';
import { SliderevealSettings, SliderevealLangs } from '../../components/slidereveal/slidereveal.model';
import { TagSettings, TagLangs } from '../../components/tag/tag.model';
import { RatingSettings, RatingLangs } from '../../components/rating/rating.model';
import { EditorSettings, EditorLangs } from '../../components/editor/editor.model';
import { FieldsetSettings } from '../../components/fieldset/fieldset.model';
import { SlidemenuSettings, SlidemenuLangs } from '../../components/slidemenu/slidemenu.model';
import { PanelmenuSettings } from '../../components/panelmenu/panelmenu.model';
import { NotifySettings } from '../../components/notify/notify.model';
import { NavbarSettings } from '../../components/navbar/navbar.model';
import { DatagridSettings, DatagridLangs } from '../../components/datagrid/datagrid.model';
import { ScrollbarSettings } from '../../components/scrollbar/scrollbar.model';
import { ValidateSettings, ValidateLangs } from '../../components/validate/validate.model';
import { PasswordSettings, PasswordLangs } from '../../components/password/password.model';
import { TypeaheadSettings, TypeaheadLangs } from '../../components/typeahead/typeahead.model';
import { CodeareaSettings } from '../../components/codearea/codearea.model';
export declare class OverwriteService implements OnInit {
    /**
     * Buttons
     */
    protected buttonsSettings: ButtonsSettings;
    /**
     * checkbox
     */
    protected checkboxSettings: CheckboxSettings;
    /**
     * Colorpicker
     */
    protected colorpickerSettings: ColorpickerSettings;
    protected colorpickerLangs: ColorpickerLangs;
    /**
     * Datagrid
     */
    protected datagridLangs: DatagridLangs;
    protected datagridSettings: DatagridSettings;
    /**
     * Datepicker
     */
    protected datepickerSettings: DatepickerSettings;
    protected datepickerLangs: DatepickerLangs;
    /**
     * Dropdown
     */
    protected dropdownSettings: DropdownSettings;
    /**
     * Editor
     */
    protected editorSettings: EditorSettings;
    protected editorLangs: EditorLangs;
    /**
     * Fieldset
     */
    protected fieldsetSettings: FieldsetSettings;
    /**
     * Fileuploader
     */
    protected fileuploaderSettings: FileuploaderSettings;
    protected fileuploaderLangs: FileuploaderLangs;
    /**
     * Input
     */
    protected inputSettings: InputSettings;
    /**
     * Password
     */
    protected passwordSettings: PasswordSettings;
    protected passwordLangs: PasswordLangs;
    /**
     * Typeahead
     */
    protected typeaheadSettings: TypeaheadSettings;
    protected typeaheadLangs: TypeaheadLangs;
    /**
     * Modal
     */
    protected modalSettings: ModalSettings;
    /**
     * Multiselect
     */
    protected multiselectSettings: MultiselectSettings;
    protected multiselectLangs: MultiselectLangs;
    /**
     * Navbar
     */
    protected navbarSettings: NavbarSettings;
    /**
     * Notify
     */
    protected notifySettings: NotifySettings;
    /**
     * Pagination
     */
    protected paginationSettings: PaginationSettings;
    protected paginationLangs: PaginationLangs;
    /**
     * Panel
     */
    protected panelSettings: PanelSettings;
    /**
     * Popover
     */
    protected popoverSettings: PopoverSettings;
    /**
     * Progress
     */
    protected progressSettings: ProgressSettings;
    /**
     * Radio
     */
    protected radioSettings: RadioSettings;
    /**
     * Rating
     */
    protected ratingSettings: RatingSettings;
    protected ratingLangs: RatingLangs;
    /**
     * Panelmenu
     */
    protected panelmenuSettings: PanelmenuSettings;
    /**
     * Select
     */
    protected selectSettings: SelectSettings;
    /**
     * Scrollbar
     */
    protected scrollbarSettings: ScrollbarSettings;
    /**
     * Slidemenu
     */
    protected slidemenuSettings: SlidemenuSettings;
    protected slidemenuLangs: SlidemenuLangs;
    /**
     * Slider
     */
    protected sliderSettings: SliderSettings;
    /**
     * Slidereveal
     */
    protected sliderevealSettings: SliderevealSettings;
    protected sliderevealLangs: SliderevealLangs;
    /**
     * Spinner
     */
    protected spinnerSettings: SpinnerSettings;
    /**
     * Switcher
     */
    protected switcherSettings: SwitcherSettings;
    protected switcherLangs: SwitcherLangs;
    /**
     * Tab
     */
    protected tabSettings: TabSettings;
    /**
     * Tag
     */
    protected tagSettings: TagSettings;
    protected tagLangs: TagLangs;
    /**
     * Codearea
     */
    protected codeareaSettings: CodeareaSettings;
    /**
     * Textarea
     */
    protected textareaSettings: TextareaSettings;
    /**
     * Tooltip
     */
    protected tooltipSettings: TooltipSettings;
    /**
     * Validate
     */
    protected validateLangs: ValidateLangs;
    protected validateSettings: ValidateSettings;
    constructor();
    ngOnInit(): void;
    /**
     * Set component default settings
     *
     * @param {string} name
     * @param {Object} settings
     * @returns {*}
     *
     * @memberOf OverwriteService
     */
    setSettings(name: string, settings: Object): any;
    /**
     * Get component default settings
     *
     * @param {string} name
     * @returns {*}
     *
     * @memberOf OverwriteService
     */
    getSettings(name: string): any;
    /**
     * Set component default langs
     *
     * @param {string} name
     * @param {Object} langs
     * @returns {*}
     *
     * @memberOf OverwriteService
     */
    setLangs(name: string, langs: Object): any;
    /**
     * Get components default langs
     *
     * @param {string} name
     * @returns {*}
     *
     * @memberOf OverwriteService
     */
    getLangs(name: string): any;
}
